// ------------------------------------------------------------------------------------
// Program:      odbc
// Purpose:      C program to demo ODBC on an Oracle 8 database table
// by:           Rock Cogar, Radian International LLC, OR TN
// date:         January 27, 2000
// Compiler:     LCC32
// Environment:  Windows NT 4.0 on Pentium III
// Style:        Win32 Console application
// DBMS:         Assumes Schema SCOTT (password ="tiger") is present with table emp
// ODBC:         Assumes ODBC alias called "oracle" points to the oracle DBMS
// ------------------------------------------------------------------------------------

#include <windows.h>
#include <stdio.h>
#include <stdlib.h>
#include <errno.h>
#include <string.h>
#include <direct.h>
#include <conio.h>
#include <io.h>
#include <sql.h>
#include <SQLEXT.H>
#include <sstream>
#include <iostream>

using std::ostringstream;
using std::cout;
using std::endl;

#define SZLEN 16
#define SZDATELEN 24

void process(void);
void dbError( LPSTR lp, HENV henv,HDBC hdbc,HSTMT hstmt);

// ------------------------------------------------------------------------------------------------------------
int main(void)
{
  process();
  return 0; 
}
// ------------------------------------------------------------------------------------------------------------

// ------------------------------------------------------------------------------------------------------------
void process(void)
{
SDWORD cbempno;
SDWORD cbename;
SDWORD cbjob;
SDWORD cbmgr;
SDWORD cbhiredate;
SDWORD cbsal;
SDWORD cbcomm;
SDWORD cbdeptno;
double dblempno;
double dblmgr;
double dblsal;
double dblcomm;
double dbldeptno;
char   szename[SZLEN+1];
char   szjob[SZLEN+1];
char   szhiredate[SZDATELEN+1];
HSTMT      hstmt;
SQLRETURN  retcode;
HENV       henv;
HDBC       hdbc;
char       szSql[256];
char       szout[256];
TIMESTAMP_STRUCT ts;

retcode = SQLAllocEnv(&henv);              /* Environment handle */

if (retcode != SQL_SUCCESS)
	{
	dbError( "SQLAllocEnv()",henv,hdbc,hstmt);
	return;
	}

retcode = SQLAllocConnect(henv, &hdbc); /* Connection handle */

if (retcode != SQL_SUCCESS)
	{
	dbError( "SQLAllocConnect()",henv,hdbc,hstmt);
	SQLFreeEnv(henv);
	return;
	}

SQLSetConnectOption(hdbc, 103, 15); /* Set login timeout to 15 seconds. */
retcode = SQLConnect(hdbc, (SQLCHAR*)"test_psql1", SQL_NTS, (SQLCHAR*)"haerterei", SQL_NTS, (SQLCHAR*)"haerterei", SQL_NTS); /* Connect to data source */

if (retcode != SQL_SUCCESS && retcode != SQL_SUCCESS_WITH_INFO)
	{
	dbError( "SQLConnect()",henv,hdbc,hstmt);
	SQLFreeEnv(henv);
	return;
	}

retcode = SQLAllocStmt(hdbc, &hstmt); /* Statement handle */

if (retcode != SQL_SUCCESS)
	{
	dbError( "SQLAllocStmt()",henv,hdbc,hstmt);
	SQLFreeEnv(henv);
	return;
	}

//lstrcpy( szSql,"select empno,ename,job,mgr,hiredate,sal,nvl(comm,0),deptno from emp order by empno asc");
 for (long i = 0; i < 100000; i++)
   {
     ostringstream befehl;
     befehl <<  "INSERT INTO testdaten1 values (" << i << ", 'zschockelt', 'tom')";
     //cout << befehl.str() << endl;
     SQLFreeStmt(hstmt, SQL_CLOSE);
     if (SQLExecDirect(hstmt, (UCHAR FAR *)befehl.str().c_str(),SQL_NTS) != SQL_SUCCESS)
       {
     	 dbError( "SQLExecDirect()", henv, hdbc, hstmt);
       }
   //  cout << i << endl;
   }

SQLFreeStmt(hstmt, SQL_DROP);
SQLDisconnect(hdbc);
SQLFreeConnect(hdbc);
SQLFreeEnv(henv);
}
// ------------------------------------------------------------------------------------------------------------

// ------------------------------------------------------------------------------------------------------------
void dbError( LPSTR lp, HENV henv,HDBC hdbc,HSTMT hstmt)
{
unsigned char buf[250];
unsigned char sqlstate[15];

SQLError( henv, hdbc, hstmt, sqlstate, NULL,buf, sizeof(buf), NULL);
fprintf(stderr, "%s. %s, SQLSTATE=%s\n",lp, buf, sqlstate);
}
// -------------------------------------------------------------------------------------------------------------


